#include "puzzle.h"

#include <stdio.h>
#include <stdlib.h>

typedef struct {
  int x;
  int y;
  int z;
} pos_t;

int busy[3][3][3];

int *check_constraints(int cube, int x, int y, int z, int *puzzle, pos_t *p)
{
  int c1, c2;
  int delta;
  int delta_x1, delta_x2;
  int delta_y1, delta_y2;
  int delta_z1, delta_z2;
  int aligned;

  while (*puzzle != CUBE && *puzzle != -1) {
    switch (*puzzle) {
    case TOUCH:
      c1 = puzzle[1];
      delta = abs(p[cube].x - p[c1].x)
            + abs(p[cube].y - p[c1].y)
            + abs(p[cube].z - p[c1].z);
printf("touch p[%d] (%d %d %d) p[%d] (%d %d %d) delta %d\n", cube, p[cube].x, p[cube].y, p[cube].z, c1, p[c1].x, p[c1].y, p[c1].z, delta);
      if (delta != 1) return NULL;
      puzzle += 2;
      break;
    case ALIGNED:
    case NOT_ALIGNED:
      c1 = puzzle[1];
      c2 = puzzle[2];
      delta_x1 = p[c2].x - p[c1].x;
      delta_x2 = p[cube].x - p[c2].x;
      delta_y1 = p[c2].y - p[c1].y;
      delta_y2 = p[cube].y - p[c2].y;
      delta_z1 = p[c2].z - p[c1].z;
      delta_z2 = p[cube].z - p[c2].z;
      aligned = delta_x1 == delta_x2
              && delta_y1 == delta_y2
              && delta_z1 == delta_z2;
printf("%s cube %d c1c2 %d %d aligned %d\n", *puzzle == ALIGNED ? "ALIGNED" : "NOT_ALIGNED", cube, c1, c2, aligned);
      if (*puzzle == ALIGNED && !aligned) return NULL;
      if (*puzzle == NOT_ALIGNED && aligned) return NULL;
      puzzle += 3;
      break;
    }
  }
  return puzzle;
}

void solve(int cube, pos_t *p, int *puzzle)
{
  int x, y, z;
  int *pz;
  if (cube == 27) {
    int i;
    printf("solution");
    for (i = 0; i < 27; i++) printf(" (%d %d %d %d)", i, p[i].x, p[i].y, p[i].z);
    printf("\n");
    return;
  }
  if (puzzle[0] != CUBE) abort();
  if (puzzle[1] != cube) abort();
  puzzle += 2;
  for (x = 0; x < 3; x++) for (y = 0; y < 3; y++) for (z = 0; z < 3; z++) {
    if (busy[x][y][z] != -1) continue;
    p[cube].x = x;
    p[cube].y = y;
    p[cube].z = z;
    pz = check_constraints(cube, x, y, z, puzzle, p);
    if (pz == NULL) continue;
    busy[x][y][z] = cube;
    solve(cube + 1, p, pz);
    busy[x][y][z] = -1;
  }
}

int main(void)
{
  pos_t p[27];
  int x, y, z;
  for (x = 0; x < 3; x++) for (y = 0; y < 3; y++) for (z = 0; z < 3; z++)
    busy[x][y][z] = -1;
  solve(0, p, puzzle_1);
  return 0;
}
